#include <gtk/gtk.h>
#include "data.h"

#include "ui.h"

#include "color_correct.h"

yuvValues pv = {
  TRUE,            /* lock graypoint */

  0,              /*gint by; */
  128,            /*gint gy; */
  255,            /*gint wy; */

  0,              /*gint bu; */
  0,              /*gint gu; */
  0,              /*gint wu; */

  0,              /*gint bv; */
  0,              /*gint gv; */
  0,              /*gint wv; */

  0,              /*gint outb; */
  255,            /*gint outw; */

  100              /*gdouble saturation; */
};

persistantValues pp = {
  TRUE,            /* prev in image */
  TRUE            /* enable vectorscope */
};

gchar *vectorscope_data = NULL;

static int values_locked = 0;


void update_values (void)
{
  values_locked++;
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (bv), pv.bv);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (bu), pv.bu);

  gtk_spin_button_set_value (GTK_SPIN_BUTTON (gu), pv.gu);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (gv), pv.gv);

  gtk_spin_button_set_value (GTK_SPIN_BUTTON (wu), pv.wu);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (wv), pv.wv);

  gtk_spin_button_set_value (GTK_SPIN_BUTTON (saturation_spin),
                             pv.saturation / 100.0);

  gtk_spin_button_set_value (GTK_SPIN_BUTTON (wy), pv.wy);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (by), pv.by);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (gy), pv.gy);

  gtk_spin_button_set_value (GTK_SPIN_BUTTON (outb), pv.outb);
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (outw), pv.outw);

  values_locked--;
}

gboolean
on_values_changed (GtkWidget      *widget,
                   GdkEventButton *event,
                   gpointer        user_data)
{
  if (!values_locked)
    {
      pv.bu = gtk_spin_button_get_value (GTK_SPIN_BUTTON (bu));
      pv.bv = gtk_spin_button_get_value (GTK_SPIN_BUTTON (bv));
      pv.by = gtk_spin_button_get_value (GTK_SPIN_BUTTON (by));

      pv.gu = gtk_spin_button_get_value (GTK_SPIN_BUTTON (gu));
      pv.gv = gtk_spin_button_get_value (GTK_SPIN_BUTTON (gv));
      pv.gy = gtk_spin_button_get_value (GTK_SPIN_BUTTON (gy));

      pv.wu = gtk_spin_button_get_value (GTK_SPIN_BUTTON (wu));
      pv.wv = gtk_spin_button_get_value (GTK_SPIN_BUTTON (wv));
      pv.wy = gtk_spin_button_get_value (GTK_SPIN_BUTTON (wy));

      pv.outb = gtk_spin_button_get_value (GTK_SPIN_BUTTON (outb));
      pv.outw = gtk_spin_button_get_value (GTK_SPIN_BUTTON (outw));

      pv.saturation =
        100 *
        gtk_spin_button_get_value (GTK_SPIN_BUTTON (saturation_spin));

      gtk_widget_queue_draw (black_drawingarea);
      gtk_widget_queue_draw (gray_drawingarea);
      gtk_widget_queue_draw (white_drawingarea);
      gtk_widget_queue_draw (levels_drawingarea);
    }
  update_image_preview ();
  return FALSE;
}
